import * as React from "react";
import * as joint from "jointjs";
declare type Port = joint.dia.Element.Port & {
    element: JSX.Element;
    id: string;
    size: {
        width: number;
        height: number;
    };
    magnet: "active" | "passive" | "none";
};
declare type Node = joint.dia.Element.Attributes & {
    element: JSX.Element;
    type: string;
    id: string;
    size: {
        width: number;
        height: number;
    };
    position: {
        x: number;
        y: number;
    };
    ports: Array<Port>;
};
export declare type Props = {
    graph: joint.dia.Graph;
    paperOptions: joint.dia.Paper.Options;
    nodes: Array<Node>;
    links: Array<joint.dia.Link>;
    paperRef?: (paper: joint.dia.Paper) => void;
};
declare type State = {
    initialized: boolean;
};
export default class ReactJointJS extends React.Component<Props, State> {
    paper: joint.dia.Paper;
    paperElement: React.RefObject<HTMLDivElement>;
    state: State;
    foreignObjectMarkup: (attributes: {
        width: number;
        height: number;
        id: string;
    } & {
        [k: string]: any;
    }) => joint.dia.MarkupJSON;
    initializeGraph: () => void;
    componentDidMount(): void;
    renderNodes: () => JSX.Element[];
    render(): JSX.Element;
}
export {};
