"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var React = require("react");
var joint = require("jointjs");
var omit = require("lodash/omit");
var Portal_1 = require("./Portal");
var ReactJointJS = /** @class */ (function (_super) {
    __extends(ReactJointJS, _super);
    function ReactJointJS() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.paper = null;
        _this.paperElement = React.createRef();
        _this.state = {
            initialized: false
        };
        _this.foreignObjectMarkup = function (attributes) { return [
            // use JSON markup instead of string to remove XML parsing step and improve perf
            {
                tagName: "foreignObject",
                attributes: __assign({}, attributes)
            }
        ]; };
        _this.initializeGraph = function () {
            _this.paper = new joint.dia.Paper(__assign(__assign({}, {
                el: _this.paperElement.current,
                model: _this.props.graph
            }), _this.props.paperOptions));
            _this.paper.freeze();
            var cells = [];
            _this.props.nodes.forEach(function (node) {
                var nodeElement = new joint.shapes.basic.Generic(__assign(__assign({}, omit(node, ["element", "ports"])), { markup: _this.foreignObjectMarkup({
                        width: node.size.width,
                        height: node.size.height,
                        id: "node_" + node.id
                    }) }));
                node.ports.forEach(function (port) {
                    return nodeElement.addPort(__assign(__assign({}, omit(port, ["element", "size", "magnet"])), { markup: _this.foreignObjectMarkup({
                            width: port.size.width,
                            height: port.size.height,
                            id: "port_" + port.id,
                            magnet: port.magnet === "none" ? undefined : port.magnet
                        }) }));
                });
                cells.push(nodeElement);
            });
            _this.props.links.forEach(function (link) {
                cells.push(link);
            });
            // much better perf than adding each cell with "graph.addCell"
            _this.props.graph.resetCells(cells);
            _this.props.paperRef && _this.props.paperRef(_this.paper);
            // handles async render
            _this.paper.on("render:done", function () {
                if (!_this.state.initialized) {
                    _this.setState({ initialized: true });
                }
            });
            // batch render all cells
            _this.paper.unfreeze();
        };
        _this.renderNodes = function () {
            return _this.props.nodes.map(function (node) {
                return (React.createElement(React.Fragment, { key: node.id },
                    React.createElement(Portal_1["default"], { id: "node_" + node.id, key: "node_" + node.id, element: node.element }),
                    node.ports.map(function (port) {
                        return (React.createElement(Portal_1["default"], { id: "port_" + port.id, key: "port_" + port.id, element: port.element }));
                    })));
            });
        };
        return _this;
    }
    ReactJointJS.prototype.componentDidMount = function () {
        this.initializeGraph();
    };
    ReactJointJS.prototype.render = function () {
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "react-joint-js-paper", ref: this.paperElement }),
            this.state.initialized && this.renderNodes()));
    };
    return ReactJointJS;
}(React.Component));
exports["default"] = ReactJointJS;
